Loading...
Searching...
No Matches
casacore::OddPolynomial< T > Class Template Reference
scimath package (libcasa_scimath) » Functionals_module

More...

`#include <OddPolynomial.h>`

## Public Member Functions

| OddPolynomial ()
| Constructs a first order polynomial, with a coeficcient of 0.0.
| OddPolynomial (uInt order)
| Makes a polynomial of the given order, with all coeficcients set to zero.
| OddPolynomial (const OddPolynomial< T > &other)
| Copy constructor/assignment (deep copy).
template<class W>
| OddPolynomial (const OddPolynomial< W > &other)
OddPolynomial< T > & | operator= (const OddPolynomial< T > &other)
virtual | ~OddPolynomial ()
| Destructor.
virtual T | eval (typename Function1D< T >::FunctionArg x) const
| Evaluate the polynomial at x.
virtual Function< T > * | clone () const
| Return a copy of this object from the heap.
virtual Function< typename FunctionTraits< T >::DiffType > * | cloneAD () const
virtual Function< typename FunctionTraits< T >::BaseType > * | cloneNonAD () const
Public Member Functions inherited from casacore::OddPolynomialParam< T >
| OddPolynomialParam ()
| Constructs a first order polynomial, with a coeficcient of 0.0.
| OddPolynomialParam (uInt order)
| Makes a polynomial of the given order, with all coeficcients set to zero.
| OddPolynomialParam (const OddPolynomialParam< T > &other)
| Make this a copy of other (deep copy).
template<class W>
| OddPolynomialParam (const OddPolynomialParam< W > &other)
OddPolynomialParam< T > & | operator= (const OddPolynomialParam< T > &other)
| ~OddPolynomialParam ()
| Destructor.
Bool | operator== (const OddPolynomialParam< T > &other) const
| Comparisons.
Bool | operator!= (const OddPolynomialParam< T > &other) const
virtual const String & | name () const
| Give name of function.
uInt | order () const
| What is the order of the polynomial, i.e.
T | coefficient (uInt which) const
| What is the which'th coefficient of the polynomial.
const Vector< T > & | coefficients () const
| Return all the coefficients as a vector.
void | setCoefficient (uInt which, const T value)
| Set the which'th coefficient to value.
void | setCoefficients (const Vector< T > &coefficients)
| Set all the coefficients at once, throw away all existing coefficients.
Public Member Functions inherited from casacore::Function1D< T, U >
| Function1D ()
| Constructors.
| Function1D (const uInt n)
| Function1D (const Vector< T > &in)
| Function1D (const FunctionParam< T > &other)
template<class W, class X>
| Function1D (const Function1D< W, X > &other)
virtual | ~Function1D ()
| Destructor.
virtual uInt | ndim () const
| Returns the number of dimensions of function.
Public Member Functions inherited from casacore::Function< T, T >
| Function ()
| Constructors.
virtual | ~Function ()
| Destructor.
uInt | nparameters () const
| Returns the number of parameters.
virtual T | eval (FunctionArg x) const=0
| Evaluate the function object.
T & | operator[] (const uInt n)
| Manipulate the nth parameter (0-based) with no index check.
virtual T | operator() () const
| Evaluate this function object at xor at x, y.
Bool & | mask (const uInt n)
| Manipulate the mask associated with the nth parameter (e.g.
const FunctionParam< T > & | parameters () const
| Return the parameter interface.
const Vector< ArgType > & | argp () const
| Get arg_p and parset_p.
Bool | parsetp () const
void | lockParam ()
| Compiler cannot always find the correct 'const' version of parameter access.
void | unlockParam ()
virtual void | setMode (const RecordInterface &mode)
| get/set the function mode.
virtual void | getMode (RecordInterface &mode) const
virtual Bool | hasMode () const
| return True if the implementing function supports a mode.
ostream & | print (ostream &os) const
| Print the function (i.e.
Public Member Functions inherited from casacore::Functional< FunctionTraits< T >::ArgType, T >
virtual | ~Functional ()
| Destructor.
virtual T | operator() (const FunctionTraits< T >::ArgType &x) const=0
| Map a Domain x into a Range y value.
Public Member Functions inherited from casacore::Functional< Vector< FunctionTraits< T >::ArgType >, T >
virtual | ~Functional ()
| Destructor.
virtual T | operator() (const Vector< FunctionTraits< T >::ArgType > &x) const=0
| Map a Domain x into a Range y value.

## Additional Inherited Members

Public Types inherited from casacore::Function1D< T, U >
typedef const T * | FunctionArg
Public Types inherited from casacore::Function< T, T >
typedef FunctionTraits< T >::ArgType | ArgType
typedef const ArgType * | FunctionArg
Protected Attributes inherited from casacore::Function< T, T >
FunctionParam< T > | param_p
| The parameters and masks.
Vector< ArgType > | arg_p
| Aid for non-contiguous argument storage.
Bool | parset_p
| Indicate parameter written.
Bool | locked_p
| Indicate that parameters are expected to be locked from changing.

## Detailed Description

template<class T>
class casacore::OddPolynomial< T >

A one dimensional odd polynomial class

### Review Status

Reviewed By:
  tcornwel
Date Reviewed:
  1996/02/22
Test programs:
  tSpecialPolynomial

### Prerequisite

- Function

### Synopsis

A OddPolynomial<T> contains a set of coefficients; its fundamental operation is evaluating itself at some "x". The number of coefficients is the order of the polynomial divided by two, plus one, so is the number of available parameters.

### Example

OddPolynomial<Float> pf(3); // Third order polynomial - coeffs 0 by default
pf.setCoefficient(0, 1.0);
pf[1] = 2.0; // 2x^3 + 1x^1
pf(2); // == 18
casacore::OddPolynomial::OddPolynomial
OddPolynomial()
Constructs a first order polynomial, with a coeficcient of 0.0.
Definition OddPolynomial.h:89

### Template Type Argument Requirements (T)

- T should have standard numerical operators. Current implementation only tested for real types (and their AutoDiffs).

### Thrown Exceptions

- Assertion in debug mode if attempt is made to address incorrect coefficients

### To Do

- Nothing I know off

Definition at line 82 of file OddPolynomial.h.

## Constructor & Destructor Documentation

## OddPolynomial() [1/4]

template<class T>

casacore::OddPolynomial< T >::OddPolynomial | ( |  | ) |

inline

Constructs a first order polynomial, with a coeficcient of 0.0.

Definition at line 89 of file OddPolynomial.h.

References casacore::OddPolynomialParam< T >::OddPolynomialParam().

Referenced by clone(), cloneAD(), cloneNonAD(), OddPolynomial(), OddPolynomial(), and operator=().

## OddPolynomial() [2/4]

template<class T>

casacore::OddPolynomial< T >::OddPolynomial | ( | uInt | order | ) |

inline explicit

Makes a polynomial of the given order, with all coeficcients set to zero.

Definition at line 92 of file OddPolynomial.h.

References casacore::OddPolynomialParam< T >::OddPolynomialParam(), and casacore::OddPolynomialParam< T >::order().

## OddPolynomial() [3/4]

template<class T>

casacore::OddPolynomial< T >::OddPolynomial | ( | const OddPolynomial< T > & | other | ) |

inline

Copy constructor/assignment (deep copy).

Definition at line 95 of file OddPolynomial.h.

References OddPolynomial(), and casacore::OddPolynomialParam< T >::OddPolynomialParam().

## OddPolynomial() [4/4]

template<class T>
template<class W>

casacore::OddPolynomial< T >::OddPolynomial | ( | const OddPolynomial< W > & | other | ) |

inline

Definition at line 98 of file OddPolynomial.h.

References OddPolynomial(), and casacore::OddPolynomialParam< T >::OddPolynomialParam().

## ~OddPolynomial()

template<class T>

virtual casacore::OddPolynomial< T >::~OddPolynomial | ( |  | ) |

inline virtual

Destructor.

Definition at line 105 of file OddPolynomial.h.

## Member Function Documentation

## clone()

template<class T>

virtual Function< T > * casacore::OddPolynomial< T >::clone | ( |  | ) | const

inline virtual

Return a copy of this object from the heap.

The caller is responsible for deleting the pointer.

Implements casacore::Function< T, T >.

Definition at line 115 of file OddPolynomial.h.

References OddPolynomial().

## cloneAD()

template<class T>

virtual Function< typename FunctionTraits< T >::DiffType > * casacore::OddPolynomial< T >::cloneAD | ( |  | ) | const

inline virtual

Reimplemented from casacore::Function< T, T >.

Definition at line 116 of file OddPolynomial.h.

References OddPolynomial().

## cloneNonAD()

template<class T>

virtual Function< typename FunctionTraits< T >::BaseType > * casacore::OddPolynomial< T >::cloneNonAD | ( |  | ) | const

inline virtual

Reimplemented from casacore::Function< T, T >.

Definition at line 118 of file OddPolynomial.h.

References OddPolynomial().

## eval()

template<class T>

virtual T casacore::OddPolynomial< T >::eval | ( | typename Function1D< T >::FunctionArg | x | ) | const

virtual

Evaluate the polynomial at x.

## operator=()

template<class T>

OddPolynomial< T > & casacore::OddPolynomial< T >::operator= | ( | const OddPolynomial< T > & | other | ) |

inline

Definition at line 100 of file OddPolynomial.h.

References OddPolynomial(), and casacore::OddPolynomialParam< T >::operator=().

The documentation for this class was generated from the following file:

- scimath/Functionals/OddPolynomial.h